## mupen64plus-ui-console 1.99.4

=== projects/unix/Makefile ===
#/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
# *   Mupen64plus - Makefile                                                *
# *   Mupen64Plus homepage: http://code.google.com/p/mupen64plus/           *
# *   Copyright (C) 2009 Richard42                                          *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.          *
# * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
# Makefile for Mupen64plus-ui-console

# detect operation system
UNAME = $(shell uname -s)
OS := NONE
ifeq ("$(UNAME)","Linux")
  OS = LINUX
endif
ifeq ("$(UNAME)","linux")
  OS = LINUX
endif
ifneq ("$(filter GNU hurd,$(UNAME))","")
  OS = LINUX
endif
ifeq ("$(UNAME)","Darwin")
  OS = OSX
endif
ifeq ("$(UNAME)","FreeBSD")
  OS = FREEBSD
endif
ifneq ("$(filter GNU/kFreeBSD kfreebsd,$(UNAME))","")
  OS = LINUX
endif
ifeq ("$(OS)","NONE")
  $(error OS type "$(UNAME)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
endif

# detect system architecture
HOST_CPU ?= $(shell uname -m)
NO_ASM ?= 1
CPU := NONE
ifneq ("$(filter x86_64 amd64,$(HOST_CPU))","")
  CPU := X86
  ifeq ("$(BITS)", "32")
    ARCH_DETECTED := 64BITS_32
  else
    ARCH_DETECTED := 64BITS
  endif
endif
ifneq ("$(filter pentium i%86,$(HOST_CPU))","")
  CPU := X86
  ARCH_DETECTED := 32BITS
endif
# PPC doesn't work yet
#ifneq ("$(filter ppc powerpc,$(HOST_CPU))","")
#  CPU := PPC
#  ARCH_DETECTED := 32BITS
#endif
#ifneq ("$(filter ppc64 powerpc64,$(HOST_CPU))","")
#  CPU := PPC
#  ARCH_DETECTED := 64BITS
#endif
ifeq ("$(CPU)","NONE")
  $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
endif

# base CFLAGS, LIBS, and LDFLAGS
CFLAGS += -ffast-math -funroll-loops -fexpensive-optimizations -fno-strict-aliasing -I../../src
LDFLAGS += -lpthread

# set special flags per-system
ifeq ($(OS), LINUX)
  ifeq ($(CPU), X86)
    ifeq ($(ARCH_DETECTED), 64BITS)
      CFLAGS += -pipe -O3 -march=athlon64
      LDFLAGS += -ldl
    else
      CFLAGS += -pipe -O3 -mmmx -msse -march=i686 -mtune=pentium-m -fomit-frame-pointer
      LDFLAGS += -ldl
    endif
  endif
endif
ifeq ($(OS), OSX)
  # The mac version of SDL requires inclusion of SDL_main in the executable
  LDFLAGS += -ldl $(shell sdl-config --libs)
  ifeq ($(CPU), X86)
    ifeq ($(ARCH_DETECTED), 64BITS)
      CFLAGS += -pipe -O3 -arch x86_64 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
      LDFLAGS += -arch x86_64
    else
      CFLAGS += -pipe -O3 -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
      LDFLAGS += -arch i686
    endif
  endif
endif
ifeq ($(CPU), PPC)
  CFLAGS += -mcpu=powerpc
endif

# tweak flags for 32-bit build on 64-bit system
ifeq ($(ARCH_DETECTED), 64BITS_32)
  ifeq ($(OS), FREEBSD)
    $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
  endif
  CFLAGS += -m32
  LDFLAGS += -m32 -m elf_i386
endif

# set mupen64plus core API header path
ifneq ("$(APIDIR)","")
  CFLAGS += "-I$(APIDIR)"
else
  TRYDIR = ../../../mupen64plus-core/src/api
  ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
    CFLAGS += -I$(TRYDIR)
  else
    TRYDIR = /usr/local/include/mupen64plus
    ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
      CFLAGS += -I$(TRYDIR)
    else
      TRYDIR = /usr/include/mupen64plus
      ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
        CFLAGS += -I$(TRYDIR)
      else
        $(error Mupen64Plus API header files not found! Use makefile parameter APIDIR to force a location.)
      endif
    endif
  endif
endif

# set shell function names
CC      ?= gcc
CXX     ?= g++
INSTALL ?= install
ifeq ($(OS),OSX)
  STRIP	?= strip -x 
else
  STRIP	?= strip -s
endif

# set special flags for given Makefile parameters
# note: COREDIR _must_ end in a slash if you want it to work; not necessary for the others
ifneq ($(PLUGINDIR),)
  CFLAGS += '-DPLUGINDIR="$(PLUGINDIR)"'
endif
ifneq ($(COREDIR),)
  CFLAGS += '-DCOREDIR="$(COREDIR)"'
endif
ifneq ($(SHAREDIR),)
  CFLAGS += '-DSHAREDIR="$(SHAREDIR)"'
endif
ifeq ($(DEBUG),1)
  CFLAGS += -g
  STRIP = true # disable binary strip
endif

# set installation options
ifeq ($(PREFIX),)
  PREFIX := /usr/local
endif
ifeq ($(BINDIR),)
  BINDIR := $(PREFIX)/bin
endif
ifeq ($(MANDIR),)
  MANDIR := $(PREFIX)/man/man6
endif

SRCDIR = ../../src
OBJDIR = _obj

# list of source files to compile
SOURCE = \
	$(SRCDIR)/cheat.c \
	$(SRCDIR)/compare_core.c \
	$(SRCDIR)/core_interface.c \
	$(SRCDIR)/main.c \
	$(SRCDIR)/plugin.c \
	$(SRCDIR)/osal_dynamiclib_unix.c \
	$(SRCDIR)/osal_files_unix.c

# generate a list of object files build, make a temporary directory for them
OBJECTS := $(patsubst $(SRCDIR)/%.c, $(OBJDIR)/%.o, $(filter %.c, $(SOURCE)))
OBJDIRS = $(dir $(OBJECTS))
$(shell mkdir -p $(OBJDIRS))

# build targets
TARGET = mupen64plus

targets:
	@echo "Mupen64Plus-ui-console makefile."
	@echo "  Targets:"
	@echo "    all            == Build Mupen64Plus console front-end application"
	@echo "    clean          == remove object files and build products"
	@echo "    rebuild        == clean and re-build all"
	@echo "    install        == Install Mupen64Plus console front-end application"
	@echo "    uninstall      == Uninstall Mupen64Plus console front-end application"
	@echo "  Options:"
	@echo "    COREDIR=path   == default path to search for Mupen64Plus Core (must end with slash)"
	@echo "    PLUGINDIR=path == default path to search for plugins"
	@echo "    SHAREDIR=path  == default path to search for shared data files"
	@echo "    APIDIR=path    == path to find Mupen64Plus Core headers"
	@echo "  Install Options:"
	@echo "    PREFIX=path    == install/uninstall prefix (default: /usr/local/)"
	@echo "    BINDIR=path    == path to install mupen64plus binary (default: PREFIX/bin/)"
	@echo "    MANDIR=path    == path to install mupen64plus manual page (default: PREFIX/man/man6/)"
	@echo "    DESTDIR=path   == path to prepend to all installation paths (only for packagers)"
	@echo "  Debugging Options:"
	@echo "    DEBUG=1        == add debugging symbols to application binary"

all: $(TARGET)

clean:
	rm -rf ./_obj/* $(TARGET)
	rmdir ./_obj

rebuild: clean all

install: $(TARGET)
	$(INSTALL) -d -v "$(DESTDIR)$(BINDIR)"
	$(INSTALL) -m 0755 $(TARGET) "$(DESTDIR)$(BINDIR)"
	$(INSTALL) -d -v "$(DESTDIR)$(MANDIR)"
	$(INSTALL) -m 0644 ../../doc/mupen64plus.6.gz "$(DESTDIR)$(MANDIR)"

uninstall:
	rm -f "$(DESTDIR)$(BINDIR)/$(TARGET)" "$(DESTDIR)$(MANDIR)/mupen64plus.6.gz"

# build dependency files
CFLAGS += -MD
-include $(OBJECTS:.o=.d)

# reduced compile output when running make without V=1
ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
	Q_CC  = @echo '    CC  '$@;
	Q_LD  = @echo '    LD  '$@;
endif
endif

# build rules
$(TARGET): $(OBJECTS)
	$(Q_LD)$(CC) $^ $(LDFLAGS) $(SRC_LIBS) -o $@
	$(STRIP) $@

$(OBJDIR)/%.o: $(SRCDIR)/%.c
	$(Q_CC)$(CC) -o $@ $(CFLAGS) -c $<

=== debian/changelog ===
mupen64plus-ui-console (1.99.4-5) unstable; urgency=low

  * Don't mix implicit and explicit rules to prevent FTBFS with make
    3.82
  * debian/patches:
    - Add cheat_leading_zeros.patch, Fix loading of cheats with leading
      zeros in CRC1/2
  * Remove hardening-includes which are now integrated in dpkg-
    buildflags
  * Use debian packaging manual URL as format identifier in
    debian/copyright

 -- Sven Eckelmann <sven@narfation.org>  Mon, 31 Oct 2011 12:49:39 +0100

mupen64plus-ui-console (1.99.4-4) unstable; urgency=low

  * Upload to unstable
  * debian/rules:
    - Mark all targets in debian/rules as phony
    - Remove unintended optimization flags
  * debian/patches:
    - Remove obsolete default-optimisations.patch
    - Add rewrite_makefile.patch, Rewrite Makefile to fix flags and
      linking
    - Add big_endian_conflict.patch, Don't use _BIG_ENDIAN to check for
      endianness

 -- Sven Eckelmann <sven@narfation.org>  Sun, 24 Jul 2011 14:24:25 +0200

mupen64plus-ui-console (1.99.4-3) experimental; urgency=low

  * Update Vcs-* fields to new anonscm.debian.org URLs in debian/control

 -- Sven Eckelmann <sven@narfation.org>  Sat, 11 Jun 2011 16:53:05 +0200

mupen64plus-ui-console (1.99.4-2) experimental; urgency=low

  * Upgraded to policy 3.9.2, no changes required
  * Provide search path to plugins and core in debian/rules

 -- Sven Eckelmann <sven@narfation.org>  Sat, 23 Apr 2011 14:37:18 +0200

mupen64plus-ui-console (1.99.4-1) experimental; urgency=low

  * New Upstream Version
  * Updated my maintainer e-mail address
  * Split source package to match upstreams modular release packages
  * debian/copyright:
    - Update to DEP5 revision 164
    - Update copyright years
  * debian/patches:
    - Rebase default-optimisations.patch against 1.99.4
    - Remove upstream merged patches: as-needed.patch,
      correct_fpr32_mapping.patch, correct_security_printf.patch,
      debian-archs.patch, dejavu-font.patch, destdir.patch,
      dont-install-unneeded.patch, fix-7z-subfolder.patch,
      fix-desktop-file.patch, fix_r0_override.patch, fix_readpng.patch,
      ftbfs-debugger.patch, ftbfs-dynarec.patch, ftbfs-glibc210.patch,
      ftbfs-gvariant-type-conflicts.patch, ftbfs-kfreebsd.patch,
      glide64_hurd.patch, glide64-noasm.patch, gtk-open-filter.patch,
      interpreter_x86_fldcw.patch, jttl_fix_romclosed.patch,
      link_gdk.patch, load_aidacrate.patch, load_vistatus.patch,
      noexecstack.patch, optional_signinfo.patch, osd-pause-crash.patch,
      path_max.patch, pie_support.patch, plugin-searchpath.patch,
      remove-gln64.patch, remove-nondfsg-icons.patch,
      resume_on_start.patch, rice-ati-symbols.patch,
      rice-crash-vendorstring.patch, rice_fog.patch, rice_nodebug.patch,
      rice-screenflickering.patch, rice-texturepack-crash.patch,
      rsp_hle_bigendian.patch, rsp_ucode2_reset.patch,
      static-binutils-libs.patch, system-libbz2.patch,
      system-liblzma.patch, system-libpng.patch, system-zlib.patch,
      version-string.patch, xdg-basedir.patch

 -- Sven Eckelmann <sven@narfation.org>  Sat, 22 Jan 2011 11:05:28 +0100

mupen64plus (1.5+dfsg1-14) experimental; urgency=low

  * Upgraded to policy 3.9.1, no changes required
  * Upgrade debhelper compat to v8
  * debian/rules:
    - set *FLAGS using dpkg-buildflags in debian/rules to work like
      dpkg-buildpackage when called directly
    - Use hardening-includes for CFLAGS and LDFLAGS hardened builds
    - Use externally provided LDFLAGS
    - Disable support for debugger due to missing pic/pie support of
      libopcodes.a
  * debian/patches:
    - Add correct_security_printf.patch, Correct possible printf format
      string vulnerability
    - Add pie_support.patch, Add support for PIE/PIC

 -- Sven Eckelmann <sven@narfation.org>  Thu, 23 Sep 2010 13:52:32 +0200

mupen64plus (1.5+dfsg1-13) unstable; urgency=low

  * debian/patches:
    - Add path_max.patch, Add dummy PATH_MAX on systems without it
      (Closes: #588066)
    - Add optional_signinfo.patch, Only use siginfo subsystem if system
      offers it (Closes: #588066)
    - Add glide64_hurd.patch, Define GNU/Hurd as UNIX system for glide64
      (Closes: #588066)

 -- Sven Eckelmann <sven@narfation.org>  Mon, 12 Jul 2010 23:20:02 +0200

mupen64plus (1.5+dfsg1-12) unstable; urgency=low

  * Use googlecode.debian.net instead of complex own filters for
    debian/watch
  * Upgraded to policy 3.9.0, no changes required
  * Build only on i386/amd64 because upstream doesn't to support more
  * debian/patches:
    - Add link_gdk.patch, Link directly against gdk-2.0 instead
      indirectly through gtk+-2.0

 -- Sven Eckelmann <sven@narfation.org>  Mon, 28 Jun 2010 21:31:48 +0200

mupen64plus (1.5+dfsg1-11) unstable; urgency=low

  * debian/patches:
    - Rename ftbfs-gvariant-type-conflicts.path to
      ftbfs-gvariant-type-conflicts.patch
    - Add rice-ati-symbols.patch, Allow to load rice on systems with
      missing opengl extensions

 -- Sven Eckelmann <sven@narfation.org>  Sun, 23 May 2010 11:55:23 +0200

mupen64plus (1.5+dfsg1-10) unstable; urgency=low

  [ Sven Eckelmann ]
  * debian/patches:
    - Add rsp_ucode2_reset.patch, Reset status of specific ucode2 hacks
      after starting again
    - Add rsp_hle_bigendian.patch, Fix wrong high level emulation of rsp
      on big endian systems
    - Add rice-crash-vendorstring.patch, Don't crash on long OpenGL
      vendor string (Closes: #580480, LP: #575968)

  [ Piotr Ożarowski ]
  * DMUA flag set to yes

 -- Sven Eckelmann <sven@narfation.org>  Thu, 06 May 2010 11:34:46 +0200

mupen64plus (1.5+dfsg1-9) unstable; urgency=low

  * debian/patches:
    - Add ftbfs-gvariant-type-conflicts.path, Fix FTBFS due to glib's
      gvariant.h type definitions (Closes: #577329)
    - Add dont-install-unneeded.patch, Don't install files which aren't
      used by us
  * debian/rules:
    - Enable parallel builds using dh's --parallel


=== debian/control ===
Source: mupen64plus-ui-console
Section: games
Priority: optional
Maintainer: Tobias Loose <TobiasLoose@gmx.de>
Uploaders: Sven Eckelmann <sven@narfation.org>
DM-Upload-Allowed: yes
Standards-Version: 3.9.2
Homepage: http://code.google.com/p/mupen64plus/
Vcs-Git: git://anonscm.debian.org/collab-maint/mupen64plus-ui-console.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mupen64plus-ui-console.git
Build-Depends:
 debhelper (>= 8.0.0),
 dpkg-dev (>= 1.16.0),
 libmupen64plus-dev,

Package: mupen64plus-ui-console
Architecture: any-i386 any-amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 mupen64plus-audio-all | mupen64plus-audio,
 mupen64plus-core-abi-1,
 mupen64plus-input-all | mupen64plus-input,
 mupen64plus-rsp-all | mupen64plus-rsp,
 mupen64plus-video-all | mupen64plus-video,
Provides:
 mupen64plus-ui,
Breaks:
 mupen64plus (<< 1.99.1)
Replaces:
 mupen64plus (<< 1.99.1)
Description: console frontend for mupen64plus
 Minimal console user interface for mupen64plus. Features provided:
  * Changeable emulation plugins for audio, core, input, rsp, video
  * Selection of emulation core
  * Graphical OSD for status output
  * Setting of configuration variable per session or in configuration file
  * Cheat database support
  * Loading of roms
 .
 It does not provide any sort of graphical setup or functionality to
 uncompress files.

Package: mupen64plus-ui-console-dbg
Section: debug
Priority: extra
Architecture: any-i386 any-amd64
Depends:
 ${misc:Depends},
 mupen64plus-ui-console (= ${binary:Version}),
Breaks: mupen64plus-dbg (<< 1.99.1)
Replaces: mupen64plus-dbg (<< 1.99.1)
Description: console frontend for mupen64plus debug symbols package
 Minimal console user interface for mupen64plus. Features provided:
  * Changeable emulation plugins for audio, core, input, rsp, video
  * Selection of emulation core
  * Graphical OSD for status output
  * Setting of configuration variable per session or in configuration file
  * Cheat database support
  * Loading of roms
 .
 It does not provide any sort of graphical setup or functionality to
 uncompress files.
 .
 This package contains the debug files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+pie
export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

LDFLAGS += -Wl,--as-needed

DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ COREDIR="/usr/lib/$(DEB_HOST_MULTIARCH)/" PLUGINDIR="/usr/lib/$(DEB_HOST_MULTIARCH)/mupen64plus" MANDIR=/usr/share/man/ BINDIR=/usr/games/ OPTFLAGS=""

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --sourcedirectory="projects/unix" --parallel --list-missing

get-orig-source:
	uscan --verbose --force-download

override_dh_auto_build:
	dh_auto_build -- all $(MAKEOPTIONS)

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS)

override_dh_strip:
	dh_strip -a --dbg-package=mupen64plus-ui-console-dbg

override_dh_installchangelogs:
	dh_installchangelogs RELEASE

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	get-orig-source override_dh_auto_build override_dh_auto_install override_dh_strip override_dh_installchangelogs

## mupen64plus-ui-console 1.99.4+27+bdcc13172958

=== debian/changelog ===
mupen64plus-ui-console (1.99.4+27+bdcc13172958-1) experimental; urgency=low

  * New upstream snapshot from revision bdcc131729587084653df131e73abd8e435e08a0
  * debian/rules:
    - Remove unnecessary --as-needed from linker flags
    - Force PIE to prevent build failures

 -- Sven Eckelmann <sven@narfation.org>  Sat, 12 Nov 2011 22:04:59 +0100

mupen64plus-ui-console (1.99.4+23+86aec84c1b27-1) experimental; urgency=low

  * New upstream snapshot from revision 86aec84c1b2735ff5d4d3f4f6b0342497d4dc5ae
  * debian/control:
    - Depend on mupen64plus-*-abi-2
    - Build-Depend on libmupen64plus-dev >= 1.99.4+77+8bb0e6b3ae3a-1
  * debian/patches:
    - Remove upstream merged patches big_endian_conflict.patch,
      rewrite_makefile.patch
  * Add debian/get-orig-source.sh for snapshots

 -- Sven Eckelmann <sven@narfation.org>  Mon, 29 Aug 2011 17:06:26 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Build-Depends:
  debhelper (>= 8.0.0),
  dpkg-dev (>= 1.16.0),
- libmupen64plus-dev,
+ libmupen64plus-dev (>= 1.99.4+77+8bb0e6b3ae3a),
 
 Package: mupen64plus-ui-console
 Architecture: any-i386 any-amd64
@@ -19,7 +19,7 @@
  ${misc:Depends},
  ${shlibs:Depends},
  mupen64plus-audio-all | mupen64plus-audio,
- mupen64plus-core-abi-1,
+ mupen64plus-core-abi-2,
  mupen64plus-input-all | mupen64plus-input,
  mupen64plus-rsp-all | mupen64plus-rsp,
  mupen64plus-video-all | mupen64plus-video,

=== debian/rules ===
--- 
+++ 
@@ -8,18 +8,15 @@
 export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
-
-LDFLAGS += -Wl,--as-needed
-
 DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
 DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
-MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ COREDIR="/usr/lib/$(DEB_HOST_MULTIARCH)/" PLUGINDIR="/usr/lib/$(DEB_HOST_MULTIARCH)/mupen64plus" MANDIR=/usr/share/man/ BINDIR=/usr/games/ OPTFLAGS=""
+MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ COREDIR="/usr/lib/$(DEB_HOST_MULTIARCH)/" PLUGINDIR="/usr/lib/$(DEB_HOST_MULTIARCH)/mupen64plus" MANDIR=/usr/share/man/ BINDIR=/usr/games/ OPTFLAGS="" PIE=1
 
 binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
 	dh $@ --sourcedirectory="projects/unix" --parallel --list-missing
 
 get-orig-source:
-	uscan --verbose --force-download
+	$(CURDIR)/debian/get-orig-source.sh
 
 override_dh_auto_build:
 	dh_auto_build -- all $(MAKEOPTIONS)

## mupen64plus-ui-console 1.99.5

=== projects/unix/Makefile ===
--- 
+++ 
@@ -38,6 +38,10 @@
 ifeq ("$(UNAME)","FreeBSD")
   OS = FREEBSD
 endif
+ifeq ("$(UNAME)","OpenBSD")
+  OS = FREEBSD
+  $(warning OS type "$(UNAME)" not officially supported.')
+endif
 ifneq ("$(filter GNU/kFreeBSD kfreebsd,$(UNAME))","")
   OS = LINUX
 endif
@@ -61,50 +65,55 @@
   CPU := X86
   ARCH_DETECTED := 32BITS
 endif
-# PPC doesn't work yet
-#ifneq ("$(filter ppc powerpc,$(HOST_CPU))","")
-#  CPU := PPC
-#  ARCH_DETECTED := 32BITS
-#endif
-#ifneq ("$(filter ppc64 powerpc64,$(HOST_CPU))","")
-#  CPU := PPC
-#  ARCH_DETECTED := 64BITS
-#endif
+ifneq ("$(filter ppc powerpc,$(HOST_CPU))","")
+  CPU := PPC
+  ARCH_DETECTED := 32BITS
+  BIG_ENDIAN := 1
+  $(warning Architecture "$(HOST_CPU)" not officially supported.')
+endif
+ifneq ("$(filter ppc64 powerpc64,$(HOST_CPU))","")
+  CPU := PPC
+  ARCH_DETECTED := 64BITS
+  BIG_ENDIAN := 1
+  $(warning Architecture "$(HOST_CPU)" not officially supported.')
+endif
 ifeq ("$(CPU)","NONE")
   $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
 endif
 
-# base CFLAGS, LIBS, and LDFLAGS
-CFLAGS += -ffast-math -funroll-loops -fexpensive-optimizations -fno-strict-aliasing -I../../src
-LDFLAGS += -lpthread
+# base CFLAGS, LDLIBS, and LDFLAGS
+OPTFLAGS ?= -O3
+CFLAGS += $(OPTFLAGS) -ffast-math -fno-strict-aliasing -pthread -I../../src
+LDLIBS += -pthread
+
+ifeq ($(PIE), 1)
+  CFLAGS += -fPIE
+  LDFLAGS += -fPIE -pie
+else
+  CFLAGS += -fno-PIE
+  LDFLAGS += -fno-PIE
+endif
 
 # set special flags per-system
 ifeq ($(OS), LINUX)
+  LDLIBS += -ldl
+endif
+ifeq ($(OS), OSX)
+  # The mac version of SDL requires inclusion of SDL_main in the executable
+  LDLIBS += -ldl $(shell sdl-config --libs)
   ifeq ($(CPU), X86)
     ifeq ($(ARCH_DETECTED), 64BITS)
-      CFLAGS += -pipe -O3 -march=athlon64
-      LDFLAGS += -ldl
-    else
-      CFLAGS += -pipe -O3 -mmmx -msse -march=i686 -mtune=pentium-m -fomit-frame-pointer
-      LDFLAGS += -ldl
-    endif
-  endif
-endif
-ifeq ($(OS), OSX)
-  # The mac version of SDL requires inclusion of SDL_main in the executable
-  LDFLAGS += -ldl $(shell sdl-config --libs)
-  ifeq ($(CPU), X86)
-    ifeq ($(ARCH_DETECTED), 64BITS)
-      CFLAGS += -pipe -O3 -arch x86_64 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
+      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
       LDFLAGS += -arch x86_64
     else
-      CFLAGS += -pipe -O3 -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
+      CFLAGS += -pipe -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
       LDFLAGS += -arch i686
     endif
   endif
 endif
-ifeq ($(CPU), PPC)
-  CFLAGS += -mcpu=powerpc
+
+ifeq ($(BIG_ENDIAN), 1)
+  CFLAGS += -DM64P_BIG_ENDIAN
 endif
 
 # tweak flags for 32-bit build on 64-bit system
@@ -113,7 +122,7 @@
     $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
   endif
   CFLAGS += -m32
-  LDFLAGS += -m32 -m elf_i386
+  LDFLAGS += -m32 -Wl,-m,elf_i386
 endif
 
 # set mupen64plus core API header path
@@ -138,15 +147,22 @@
   endif
 endif
 
-# set shell function names
-CC      ?= gcc
-CXX     ?= g++
-INSTALL ?= install
-ifeq ($(OS),OSX)
-  STRIP	?= strip -x 
-else
-  STRIP	?= strip -s
-endif
+# reduced compile output when running make without V=1
+ifneq ($(findstring $(MAKEFLAGS),s),s)
+ifndef V
+	Q_CC  = @echo '    CC  '$@;
+	Q_LD  = @echo '    LD  '$@;
+endif
+endif
+
+# set base program pointers and flags
+CC       ?= gcc
+CXX      ?= g++
+RM       ?= rm -f
+INSTALL  ?= install
+MKDIR ?= mkdir -p
+COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
+LINK.o = $(Q_LD)$(CC) $(LDFLAGS) $(TARGET_ARCH)
 
 # set special flags for given Makefile parameters
 # note: COREDIR _must_ end in a slash if you want it to work; not necessary for the others
@@ -161,7 +177,9 @@
 endif
 ifeq ($(DEBUG),1)
   CFLAGS += -g
-  STRIP = true # disable binary strip
+  INSTALL_STRIP_FLAG ?= 
+else
+  INSTALL_STRIP_FLAG ?= -s
 endif
 
 # set installation options
@@ -172,7 +190,7 @@
   BINDIR := $(PREFIX)/bin
 endif
 ifeq ($(MANDIR),)
-  MANDIR := $(PREFIX)/man/man6
+  MANDIR := $(PREFIX)/share/man
 endif
 
 SRCDIR = ../../src
@@ -191,7 +209,7 @@
 # generate a list of object files build, make a temporary directory for them
 OBJECTS := $(patsubst $(SRCDIR)/%.c, $(OBJDIR)/%.o, $(filter %.c, $(SOURCE)))
 OBJDIRS = $(dir $(OBJECTS))
-$(shell mkdir -p $(OBJDIRS))
+$(shell $(MKDIR) $(OBJDIRS))
 
 # build targets
 TARGET = mupen64plus
@@ -209,47 +227,42 @@
 	@echo "    PLUGINDIR=path == default path to search for plugins"
 	@echo "    SHAREDIR=path  == default path to search for shared data files"
 	@echo "    APIDIR=path    == path to find Mupen64Plus Core headers"
+	@echo "    OPTFLAGS=flags == compiler optimization (default: -O3)"
+	@echo "    PIE=(1|0)      == Force enable/disable of position independent executables"
 	@echo "  Install Options:"
 	@echo "    PREFIX=path    == install/uninstall prefix (default: /usr/local/)"
 	@echo "    BINDIR=path    == path to install mupen64plus binary (default: PREFIX/bin/)"
-	@echo "    MANDIR=path    == path to install mupen64plus manual page (default: PREFIX/man/man6/)"
+	@echo "    MANDIR=path    == path to install mupen64plus manual page (default: PREFIX/share/man)"
 	@echo "    DESTDIR=path   == path to prepend to all installation paths (only for packagers)"
 	@echo "  Debugging Options:"
 	@echo "    DEBUG=1        == add debugging symbols to application binary"
+	@echo "    V=1            == show verbose compiler output"
 
 all: $(TARGET)
 
 clean:
-	rm -rf ./_obj/* $(TARGET)
-	rmdir ./_obj
+	$(RM) -r ./_obj $(TARGET)
 
 rebuild: clean all
 
 install: $(TARGET)
-	$(INSTALL) -d -v "$(DESTDIR)$(BINDIR)"
-	$(INSTALL) -m 0755 $(TARGET) "$(DESTDIR)$(BINDIR)"
-	$(INSTALL) -d -v "$(DESTDIR)$(MANDIR)"
-	$(INSTALL) -m 0644 ../../doc/mupen64plus.6.gz "$(DESTDIR)$(MANDIR)"
+	$(INSTALL) -d "$(DESTDIR)$(BINDIR)"
+	$(INSTALL) -m 0755 $(INSTALL_STRIP_FLAG) $(TARGET) "$(DESTDIR)$(BINDIR)"
+	$(INSTALL) -d "$(DESTDIR)$(MANDIR)/man6"
+	$(INSTALL) -m 0644 ../../doc/mupen64plus.6.gz "$(DESTDIR)$(MANDIR)/man6"
 
 uninstall:
-	rm -f "$(DESTDIR)$(BINDIR)/$(TARGET)" "$(DESTDIR)$(MANDIR)/mupen64plus.6.gz"
+	$(RM) "$(DESTDIR)$(BINDIR)/$(TARGET)" "$(DESTDIR)$(MANDIR)/man6/mupen64plus.6.gz"
 
 # build dependency files
 CFLAGS += -MD
 -include $(OBJECTS:.o=.d)
 
-# reduced compile output when running make without V=1
-ifneq ($(findstring $(MAKEFLAGS),s),s)
-ifndef V
-	Q_CC  = @echo '    CC  '$@;
-	Q_LD  = @echo '    LD  '$@;
-endif
-endif
-
-# build rules
+# standard build rules
+$(OBJDIR)/%.o: $(SRCDIR)/%.c
+	$(COMPILE.c) -o $@ $<
+
 $(TARGET): $(OBJECTS)
-	$(Q_LD)$(CC) $^ $(LDFLAGS) $(SRC_LIBS) -o $@
-	$(STRIP) $@
-
-$(OBJDIR)/%.o: $(SRCDIR)/%.c
-	$(Q_CC)$(CC) -o $@ $(CFLAGS) -c $<
+	$(LINK.o) $^ $(LOADLIBES) $(LDLIBS) -o $@
+
+.PHONY: all clean install uninstall targets

=== debian/changelog ===
mupen64plus-ui-console (1.99.5-3) unstable; urgency=low

  * debian/patches:
    - Add gcc_lto.patch, Enable support for link-time optimization

 -- Sven Eckelmann <sven@narfation.org>  Sat, 09 Jun 2012 01:12:04 +0200

mupen64plus-ui-console (1.99.5-2) unstable; urgency=low

  [ Simon Ruderich ]
  * Let debhelper set the buildflags implicitly

  [ Sven Eckelmann ]
  * Depend on mupen64plus-data for cheat database
  * Remove unnecessary break against mupen64plus-dbg

 -- Sven Eckelmann <sven@narfation.org>  Mon, 28 May 2012 00:21:43 +0200

mupen64plus-ui-console (1.99.5-1) unstable; urgency=low

  * Update copyright years in debian/copyright
  * Enable all hardening flags in debian/rules
  * Upgraded to policy 3.9.3, no changes required
  * Upgrade debhelper compat to v9
  * Use buildflags.mk to set security flags in debian/rules

 -- Sven Eckelmann <sven@narfation.org>  Sat, 17 Mar 2012 20:18:36 +0100

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Maintainer: Tobias Loose <TobiasLoose@gmx.de>
 Uploaders: Sven Eckelmann <sven@narfation.org>
 DM-Upload-Allowed: yes
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://code.google.com/p/mupen64plus/
 Vcs-Git: git://anonscm.debian.org/collab-maint/mupen64plus-ui-console.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mupen64plus-ui-console.git
 Build-Depends:
- debhelper (>= 8.0.0),
- dpkg-dev (>= 1.16.0),
- libmupen64plus-dev (>= 1.99.4+77+8bb0e6b3ae3a),
+ debhelper (>= 9),
+ dpkg-dev (>= 1.16.1.1),
+ libmupen64plus-dev (>= 1.99.5),
 
 Package: mupen64plus-ui-console
 Architecture: any-i386 any-amd64
@@ -19,7 +19,9 @@
  ${misc:Depends},
  ${shlibs:Depends},
  mupen64plus-audio-all | mupen64plus-audio,
- mupen64plus-core-abi-2,
+ mupen64plus-config-abi-2.2,
+ mupen64plus-data,
+ mupen64plus-frontend-abi-2.0.1,
  mupen64plus-input-all | mupen64plus-input,
  mupen64plus-rsp-all | mupen64plus-rsp,
  mupen64plus-video-all | mupen64plus-video,
@@ -48,8 +50,6 @@
 Depends:
  ${misc:Depends},
  mupen64plus-ui-console (= ${binary:Version}),
-Breaks: mupen64plus-dbg (<< 1.99.1)
-Replaces: mupen64plus-dbg (<< 1.99.1)
 Description: console frontend for mupen64plus debug symbols package
  Minimal console user interface for mupen64plus. Features provided:
   * Changeable emulation plugins for audio, core, input, rsp, video

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ COREDIR="/usr/lib/$(DEB_HOST_MULTIARCH)/" PLUGINDIR="/usr/lib/$(DEB_HOST_MULTIARCH)/mupen64plus" MANDIR=/usr/share/man/ BINDIR=/usr/games/ OPTFLAGS="" PIE=1 LTO=1
DBG_PACKAGE=$(shell dpkg-parsechangelog|grep '^Source: '|sed 's/^Source:\s*//')-dbg

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --sourcedirectory="projects/unix" --parallel --list-missing

get-orig-source:
	$(CURDIR)/debian/get-orig-source.sh

override_dh_auto_build:
	dh_auto_build -- all $(MAKEOPTIONS)

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS)

override_dh_strip:
	dh_strip -a --dbg-package="$(DBG_PACKAGE)"

override_dh_installchangelogs:
	dh_installchangelogs RELEASE

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	get-orig-source override_dh_auto_build override_dh_auto_install override_dh_strip override_dh_installchangelogs

=== debian/watch ===
version=3

http://bitbucket.org/richard42/mupen64plus-ui-console/downloads/ \
	/richard42/mupen64plus-ui-console/downloads/mupen64plus-ui-console-src-(.*).tar.gz

## mupen64plus-ui-console 2.0

=== projects/unix/Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
 # Makefile for Mupen64plus-ui-console
 
 # detect operation system
-UNAME = $(shell uname -s)
+UNAME ?= $(shell uname -s)
 OS := NONE
 ifeq ("$(UNAME)","Linux")
   OS = LINUX
@@ -44,6 +44,9 @@
 endif
 ifneq ("$(filter GNU/kFreeBSD kfreebsd,$(UNAME))","")
   OS = LINUX
+endif
+ifeq ("$(patsubst MINGW%,MINGW,$(UNAME))","MINGW")
+  OS = MINGW
 endif
 ifeq ("$(OS)","NONE")
   $(error OS type "$(UNAME)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
@@ -65,7 +68,7 @@
   CPU := X86
   ARCH_DETECTED := 32BITS
 endif
-ifneq ("$(filter ppc powerpc,$(HOST_CPU))","")
+ifneq ("$(filter ppc macppc socppc powerpc,$(HOST_CPU))","")
   CPU := PPC
   ARCH_DETECTED := 32BITS
   BIG_ENDIAN := 1
@@ -77,21 +80,35 @@
   BIG_ENDIAN := 1
   $(warning Architecture "$(HOST_CPU)" not officially supported.')
 endif
+ifneq ("$(filter arm%,$(HOST_CPU))","")
+  ifeq ("$(filter arm%b,$(HOST_CPU))","")
+    CPU := ARM
+    ARCH_DETECTED := 32BITS
+    $(warning Architecture "$(HOST_CPU)" not officially supported.')
+  endif
+endif
 ifeq ("$(CPU)","NONE")
   $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
 endif
 
 # base CFLAGS, LDLIBS, and LDFLAGS
-OPTFLAGS ?= -O3
-CFLAGS += $(OPTFLAGS) -ffast-math -fno-strict-aliasing -pthread -I../../src
-LDLIBS += -pthread
+OPTFLAGS ?= -O3 -flto
+WARNFLAGS ?= -Wall
+
+CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -ffast-math -fno-strict-aliasing -I../../src
+ifeq ($(OS), MINGW)
+  CFLAGS += -lpthread
+  LDLIBS += -lpthread
+else
+  CFLAGS += -pthread
+  LDLIBS += -pthread
+endif
 
 ifeq ($(PIE), 1)
   CFLAGS += -fPIE
-  LDFLAGS += -fPIE -pie
+  LDFLAGS += -pie
 else
   CFLAGS += -fno-PIE
-  LDFLAGS += -fno-PIE
 endif
 
 # set special flags per-system
@@ -99,17 +116,41 @@
   LDLIBS += -ldl
 endif
 ifeq ($(OS), OSX)
-  # The mac version of SDL requires inclusion of SDL_main in the executable
-  LDLIBS += -ldl $(shell sdl-config --libs)
+  # Select the proper SDK
+  # Also, SDKs are stored in a different location since XCode 4.3
+  OSX_SDK ?= $(shell sw_vers -productVersion | cut -f1 -f2 -d .)
+  OSX_XCODEMAJ = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f1 -d .)
+  OSX_XCODEMIN = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f2 -d .)
+  OSX_XCODEGE43 = $(shell echo "`expr $(OSX_XCODEMAJ) \>= 4``expr $(OSX_XCODEMIN) \>= 3`")
+  ifeq ($(OSX_XCODEGE43), 11)
+    OSX_SYSROOT := /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs
+  else
+    OSX_SYSROOT := /Developer/SDKs
+  endif
+
   ifeq ($(CPU), X86)
     ifeq ($(ARCH_DETECTED), 64BITS)
-      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
-      LDFLAGS += -arch x86_64
+      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
     else
-      CFLAGS += -pipe -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
-      LDFLAGS += -arch i686
+      CFLAGS += -pipe -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
     endif
   endif
+endif
+
+# test for presence of SDL
+ifeq ($(origin SDL_CFLAGS) $(origin SDL_LDLIBS), undefined undefined)
+  SDL_CONFIG = $(CROSS_COMPILE)sdl-config
+  ifeq ($(shell which $(SDL_CONFIG) 2>/dev/null),)
+    $(error No SDL development libraries found!)
+  endif
+  SDL_CFLAGS  += $(shell $(SDL_CONFIG) --cflags)
+  SDL_LDLIBS += $(shell $(SDL_CONFIG) --libs)
+endif
+CFLAGS += $(SDL_CFLAGS)
+LDLIBS += $(SDL_LDLIBS)
+
+ifeq ($(OS), MINGW)
+  LDLIBS += -mconsole
 endif
 
 ifeq ($(BIG_ENDIAN), 1)
@@ -122,7 +163,7 @@
     $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
   endif
   CFLAGS += -m32
-  LDFLAGS += -m32 -Wl,-m,elf_i386
+  LDFLAGS += -Wl,-m,elf_i386
 endif
 
 # set mupen64plus core API header path
@@ -156,13 +197,13 @@
 endif
 
 # set base program pointers and flags
-CC       ?= gcc
-CXX      ?= g++
+CC        = $(CROSS_COMPILE)gcc
+CXX       = $(CROSS_COMPILE)g++
 RM       ?= rm -f
 INSTALL  ?= install
 MKDIR ?= mkdir -p
 COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
-LINK.o = $(Q_LD)$(CC) $(LDFLAGS) $(TARGET_ARCH)
+LINK.o = $(Q_LD)$(CC) $(CFLAGS) $(LDFLAGS) $(TARGET_ARCH)
 
 # set special flags for given Makefile parameters
 # note: COREDIR _must_ end in a slash if you want it to work; not necessary for the others
@@ -194,7 +235,13 @@
 endif
 
 SRCDIR = ../../src
-OBJDIR = _obj
+OBJDIR = _obj$(POSTFIX)
+
+ifeq ("$(OS)","MINGW")
+  EXEEXT = .exe
+else
+  EXEEXT =
+endif
 
 # list of source files to compile
 SOURCE = \
@@ -202,9 +249,17 @@
 	$(SRCDIR)/compare_core.c \
 	$(SRCDIR)/core_interface.c \
 	$(SRCDIR)/main.c \
-	$(SRCDIR)/plugin.c \
+	$(SRCDIR)/plugin.c
+
+ifeq ($(OS), MINGW)
+SOURCE += \
+	$(SRCDIR)/osal_dynamiclib_win32.c \
+	$(SRCDIR)/osal_files_win32.c
+else
+SOURCE += \
 	$(SRCDIR)/osal_dynamiclib_unix.c \
 	$(SRCDIR)/osal_files_unix.c
+endif
 
 # generate a list of object files build, make a temporary directory for them
 OBJECTS := $(patsubst $(SRCDIR)/%.c, $(OBJDIR)/%.o, $(filter %.c, $(SOURCE)))
@@ -212,7 +267,7 @@
 $(shell $(MKDIR) $(OBJDIRS))
 
 # build targets
-TARGET = mupen64plus
+TARGET = mupen64plus$(POSTFIX)$(EXEEXT)
 
 targets:
 	@echo "Mupen64Plus-ui-console makefile."
@@ -227,8 +282,10 @@
 	@echo "    PLUGINDIR=path == default path to search for plugins"
 	@echo "    SHAREDIR=path  == default path to search for shared data files"
 	@echo "    APIDIR=path    == path to find Mupen64Plus Core headers"
-	@echo "    OPTFLAGS=flags == compiler optimization (default: -O3)"
+	@echo "    OPTFLAGS=flags == compiler optimization (default: -O3 -flto)"
+	@echo "    WARNFLAGS=flag == compiler warning levels (default: -Wall)"
 	@echo "    PIE=(1|0)      == Force enable/disable of position independent executables"
+	@echo "    POSTFIX=name  == String added to the name of the the build (default: '')"
 	@echo "  Install Options:"
 	@echo "    PREFIX=path    == install/uninstall prefix (default: /usr/local/)"
 	@echo "    BINDIR=path    == path to install mupen64plus binary (default: PREFIX/bin/)"
@@ -241,7 +298,7 @@
 all: $(TARGET)
 
 clean:
-	$(RM) -r ./_obj $(TARGET)
+	$(RM) -r $(OBJDIR) $(TARGET)
 
 rebuild: clean all
 
@@ -249,10 +306,10 @@
 	$(INSTALL) -d "$(DESTDIR)$(BINDIR)"
 	$(INSTALL) -m 0755 $(INSTALL_STRIP_FLAG) $(TARGET) "$(DESTDIR)$(BINDIR)"
 	$(INSTALL) -d "$(DESTDIR)$(MANDIR)/man6"
-	$(INSTALL) -m 0644 ../../doc/mupen64plus.6.gz "$(DESTDIR)$(MANDIR)/man6"
+	$(INSTALL) -m 0644 ../../doc/mupen64plus.6 "$(DESTDIR)$(MANDIR)/man6"
 
 uninstall:
-	$(RM) "$(DESTDIR)$(BINDIR)/$(TARGET)" "$(DESTDIR)$(MANDIR)/man6/mupen64plus.6.gz"
+	$(RM) "$(DESTDIR)$(BINDIR)/$(TARGET)" "$(DESTDIR)$(MANDIR)/man6/mupen64plus.6"
 
 # build dependency files
 CFLAGS += -MD

=== debian/changelog ===
mupen64plus-ui-console (2.0-1) unstable; urgency=low

  * New Upstream Version
  * Upload to unstable
  * debian/control:
    - Depend on libsdl2-dev for new SDLmain function
    - Build-Depend on debhelper 9.20130604 for support of parameters when
      detecting targets in dh_auto_*
  * debian/rules:
    - Build against SDL2
    - Work around new debhelper 9.20130624 dh_auto_{clean,test} behavior
      which is causing a FTBFS by adding an explicit
      override_dh_auto_{clean,test} rule
  * debian/watch:
    - Verify new upstream versions using GPG key 954F81B094AA5BB226F5

 -- Sven Eckelmann <sven@narfation.org>  Fri, 05 Jul 2013 22:53:14 +0200

mupen64plus-ui-console (2.0~rc2+1+b39a4ffc9d54-2) experimental; urgency=low

  * debian/rules:
    - Disable -flto and -fPIC because GCC 4.8 still has problems when used
      together with PIE

 -- Sven Eckelmann <sven@narfation.org>  Sun, 23 Jun 2013 13:25:35 +0200

mupen64plus-ui-console (2.0~rc2+1+b39a4ffc9d54-1) experimental; urgency=low

  * New Upstream Snapshot from b39a4ffc9d54aabd72ae95947b7b046e2e1a56bb
  * Depend on mupen64plus-frontend-abi-2.1.1 in debian/control
  * debian/rules
    - Enable link-time optimization in debian/rules similar to upstream
    - Enable -fPIC to fix build error with pie enabled

 -- Sven Eckelmann <sven@narfation.org>  Wed, 05 Jun 2013 13:57:05 +0200

mupen64plus-ui-console (1.99.5+22+0f89ae786d3e-1) experimental; urgency=low

  * New Upstream Snapshot from 0f89ae786d3e03baf658c70a34d3389beaa897d7
  * Disable extra debug code in release builds with -DNDEBUG in
    debian/rules

 -- Sven Eckelmann <sven@narfation.org>  Fri, 08 Feb 2013 10:16:05 +0100

mupen64plus-ui-console (1.99.5+8+0f9dd3c1dd6d-1) experimental; urgency=low

  * New Upstream Snapshot from 0f9dd3c1dd6de4e65ed98fb9745448cacb5a13b5
  * Upgraded to policy 3.9.4, no changes required
  * Remove obsolete DM-Upload-Allowed in debian/control

 -- Sven Eckelmann <sven@narfation.org>  Sun, 02 Dec 2012 22:34:01 +0100

mupen64plus-ui-console (1.99.5+6+a10c576ef396-1) experimental; urgency=low

  * New Upstream Snapshot from a10c576ef39638f14e40010836c409de2d6ac6b4
  * debian/patches:
    - Add printf_fixup.patch, Add printf-format attribute

 -- Sven Eckelmann <sven@narfation.org>  Tue, 11 Sep 2012 21:24:53 +0200

mupen64plus-ui-console (1.99.5+3+19265d7e8658-1) experimental; urgency=low

  * New Upstream Snapshot from 19265d7e8658a243557e17d74674d8fe2fed7dcf
  * debian/patches:
    - Remove upstream merged gcc_lto.patch

 -- Sven Eckelmann <sven@narfation.org>  Sun, 17 Jun 2012 00:55:06 +0200

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,15 @@
 Priority: optional
 Maintainer: Tobias Loose <TobiasLoose@gmx.de>
 Uploaders: Sven Eckelmann <sven@narfation.org>
-DM-Upload-Allowed: yes
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://code.google.com/p/mupen64plus/
 Vcs-Git: git://anonscm.debian.org/collab-maint/mupen64plus-ui-console.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mupen64plus-ui-console.git
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 9.20130604),
  dpkg-dev (>= 1.16.1.1),
  libmupen64plus-dev (>= 1.99.5),
+ libsdl2-dev,
 
 Package: mupen64plus-ui-console
 Architecture: any-i386 any-amd64
@@ -21,7 +21,7 @@
  mupen64plus-audio-all | mupen64plus-audio,
  mupen64plus-config-abi-2.2,
  mupen64plus-data,
- mupen64plus-frontend-abi-2.0.1,
+ mupen64plus-frontend-abi-2.1.1,
  mupen64plus-input-all | mupen64plus-input,
  mupen64plus-rsp-all | mupen64plus-rsp,
  mupen64plus-video-all | mupen64plus-video,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ COREDIR="/usr/lib/$(DEB_HOST_MULTIARCH)/" PLUGINDIR="/usr/lib/$(DEB_HOST_MULTIARCH)/mupen64plus" MANDIR=/usr/share/man/ BINDIR=/usr/games/ OPTFLAGS="-DNDEBUG" PIE=1 SDL_CONFIG=sdl2-config
DBG_PACKAGE=$(shell dpkg-parsechangelog|grep '^Source: '|sed 's/^Source:\s*//')-dbg

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --sourcedirectory="projects/unix" --parallel --list-missing

get-orig-source:
	$(CURDIR)/debian/get-orig-source.sh

override_dh_auto_test:
	# otherwise dh_auto_test fails with debhelper 9.20130624

override_dh_auto_clean:
	dh_auto_clean -- $(MAKEOPTIONS)

override_dh_auto_build:
	dh_auto_build -- all $(MAKEOPTIONS)

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS)

override_dh_strip:
	dh_strip -a --dbg-package="$(DBG_PACKAGE)"

override_dh_installchangelogs:
	dh_installchangelogs RELEASE

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	get-orig-source override_dh_auto_clean override_dh_auto_test override_dh_auto_build override_dh_auto_install override_dh_strip override_dh_installchangelogs

=== debian/watch ===
version=3

opts="pgpsigurlmangle=s/$/.asc/" \
 http://bitbucket.org/richard42/mupen64plus-ui-console/downloads/ \
	/richard42/mupen64plus-ui-console/downloads/mupen64plus-ui-console-src-(.*).tar.gz
